﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Konfiguration                                                                       //
//  _____________________________________________________                               //
//                                                                                      //
//  Copyright (c) 2019 Reimar Grasbon                                                   //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Typenschild  //////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define DEV_APPL_TYPE                    00317  // Anwendungstypennummer:                00100 ..  99999 [#]
#define DEV_APPL_VERS                       16  // Anwendungsversion (Major.Minor):         01 ..     99 [#]
#define DEV_BOARD_TYPE                   00105  // Boardtypennummer:                     00001 ..  99999 [#]
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define GENADR_A(T) (100 + (10 ## T))           // GENADR_XX erzeugt aus den beiden letzten Stellen der
#define GENADR_B(X) GENADR_A(X%100)             // Boardtypennummer in <DEV_BOARD_TYPE> die werksvoreinge-
#define GENADR_XX   GENADR_B(DEV_BOARD_TYPE)    // stellte Geräteadresse gemäß Cy4NET-Konvention: 100 + xx

///////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Konfiguration  ////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define CFG_PGMLDR_SIZE                      4  // Größe des Programmladers                   1/2/4       [KiB]
#define CFG_EEP_CY4_ADDRESS_PARTITION        2  // EEProm-Start der Cy4-Adress-Partition:     0 ..  1023  [#]
#define CFG_EEP_STORING_PARTITION           10  // EEProm-Start der Datenaufbewahrungs-Part.: 0 ..  1023  [#]
#define CFG_DEFAULT_CY4_ADDRESS_NET        255  // Voreingestellte-Cy4-Netzadresse:           1 ..   255  [#]
#define CFG_DEFAULT_CY4_ADDRESS_DEV  GENADR_XX  // Voreingestellte-Cy4-Geräteadresse:         1 ..   254  [#]
#define CFG_CY4_POSTING_QUEUE_CAPACITY      15  // Kapazität der CY4-Sendeschlange:           1 ..   100  [Sendungen]
#define CFG_BUS_TX_QUEUE_CAPACITY           75  // Kapazität der Bus-Sendeschlange:          75 ..   120  [Bytes]
#define CFG_BUS_RX_QUEUE_CAPACITY          160  // Kapazität der Bus-Empfangsschlange:       76 ..   250  [Bytes]
#define CFG_BUS_INTERBYTE_TIMEOUT            3  // Zeitüberschreit. bei Bus-Byteübertr.:      1 ..    30  [ms]
#define CFG_BUS_ACT_LED_FLASH               25  // LED-Leuchtdauer bei Bus-Aktivität:         0 ..   250  [ms]
#define CFG_SER_TX_QUEUE_CAPACITY          240  // Kapazität der Seriellen Sendeschlange:     1 ..   250  [Byte]
#define CFG_SER_RX_QUEUE_CAPACITY          240  // Kapazität der Seriellen Empfangsschlange:  1 ..   250  [Byte]
#define CFG_SER_LINE_CAPACITY              144  // Kapazität einer seriellen Text-Zeile:    144 ..   255  [Zeichen]
#define CFG_SER_LINE_BREAK               "\r\n" // Zeilenumbruch bei ASCII-Ausgabe:          Zeichenkette [Zeichen]
#define CFG_SER_ACT_LED_FLASH               25  // LED-Leuchtdauer bei RS232-Aktivität:       0 ..   250  [ms]
#define CFG_POSTING_TIMEOUT                700  // Zeitgrenze für ausgehende Beförderung:   650 ..  3000  [ms]
#define CFG_PB_DOWN_RESPONSIVITY            10  // Ansprechempfind. Drucktaste drücken:       0 ..   250  [ms]
#define CFG_PB_UP_RESPONSIVITY              50  // Ansprechempfind. Drucktaste loslassen:     0 ..   250  [ms]

///////////////////////////////////////////////////////////////////////////////////////////////////////////
